package conf;
use strict;
use warnings;

#
# This file should not be removed.
# Either edit it directly or make your changes in another file (eg: your.conf) and run ./sqlsus -c your.conf
#

###############################
########### GENERAL ###########

# Start of the url used for the injection
# In inband mode, it is generally a good idea to append "AND 1=0" so that the real query returns nothing.
# APPEND A SPACE IF NEEDED
# Ex : our $url_start = "http://localhost/script.php?id=1' ";
our $url_start = "http://localhost/script.php?id=1' ";

# End of the url used for the injection
# PREFIX WITH A SPACE IF NEEDED
# Ex : our $url_end = "#'";
our $url_end = "#'";

# Use blind injection ?
our $blind = 0;

# In blind mode, string to be found in the HTML if the statement is true
our $string_to_match = "";

# use POST instead of GET
our $post = 0; 

# user agent to use for http queries
our $user_agent = "Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)";

# display "debug" messages
our $debug = 0;

# char (not string) to display when something is null / not found
our $null_substitute = "~";

# Hex encode strings in the query ?
our $hex_encode_strings = 1;

# maximum running processes at a time (+ the main process).
# Only used in blind mode for the moment.
# minimum value: 1
our $processes = 10;

# amount of seconds to sleep after each server hit.
# note that it does not take the query / answer time in consideration, it's just a simple sleep() after a hit.
# also note that you can use floating values, because sqlsus uses Time::HiRes
our $sleep_after_hit = 0;

# max chars we can inject.
# if you are using injection via POST, you can set it to a big value, and control the behaviour of sqlsus via max_subqueries
our $max_sendable = 4006;

# max subqueries per query
# minimum value: 1
our $max_subqueries = 50;

# Cookie to use, separate name=value pairs with ;
our $cookie = "";

# http proxy 
our $http_proxy = "";

# credentials
our $cred_realm = "";
our $cred_user = "";
our $cred_password  = "";


###############################
############ DATA #############

# where to put the data
our $datapath = "data";

# where to save downloaded files (via the "download" command)
# such files will be stored in ./$datapath/$server/$filespath
our $filespath = "files";

###############################
######### INBAND MODE ########

# maximum number of columns to try in the union statement
our $max_select_cols = 30;

# columns usable for (inband) injection using union
# example : 
# our @columns = qw(0 0 1 0 1);
# 5 columns for union, 3rd and 5th can be used to see the result of the query
our @columns = qw();

# how to union
our $union_select = "UNION ALL SELECT";

###############################
######### BLIND MODE ##########

# Chars to brute force if no regex matched
our $default_range = join (',', (32..126));

# regexs to test against each item retrieved on a blind injection
# and the corresponding ASCII values.
# NOTE: 
# - the values MUST be sorted.
# - the regexs will be tried in order.
our @regex_rlike = (
	# num
	"^[0-9]+\$", join (',',(48..57)),
	# low alpha
	"^[a-z_\. @]+\$", join (',',(32,46,64,95,97..122)),
	# hex
	"^[a-f0-9]+\$", join (',',(48..57,97..102)),
	"^[A-F0-9]+\$", join (',',(48..57,65..70)),
	# upper alpha
	"^[A-Z_\. @]+\$", join (',',(32,46,64,65..90,95)),
	# alpha
	"^[A-Za-z_\. @]+\$", join (',',(32,46,64,65..90,95,97..122)),
	# alnum
	"^[a-z0-9\._@]+\$", join (',',(46,48..57,64,95,97..122)),
	"^[A-Za-z0-9\._@]+\$", join (',',(46,48..57,64,65..90,95,97..122))
);

# Max length above which an item won't be bruteforced
our $max_length = 4096;


###############################
########## TAKEOVER ###########

# document root on the web server
our $document_root = "/var/www/";

# list of (relative to document root path) directories to try to upload backdoor to
# leave empty for auto detection by crawling the web server
# ex : our @upload_directories = ("/upload");
our @upload_directories = ();

# maximum depth to look at when crawling the web server for directories
our $crawler_depth = 3;

# url of the uploader script, if already uploaded
our $uploader = "";


###############################
############ CORE #############

# Tables correspondances inside information_schema, when available
our %tables = (
    user_privs      => 'information_schema.user_privileges',
    database_privs  => 'information_schema.schema_privileges',
    tables          => 'information_schema.tables',
    columns         => 'information_schema.columns'
    );

# Variables to get in %target when using "start"
our @target_at_start = qw(version user database);

# %target keys
our %target_keys = (
    version		=> 'version()',
    user 		=> 'current_user',
    database	=> 'database()',
    datadir 	=> '@@datadir'
    );

1

